using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using RAIN.Action;
using RAIN.Core;
using RAIN.Representation;
using RAIN.Motion;

[RAINAction]
public class getRandomPoint : RAINAction
{
	public Expression TagVar = new Expression();
    public Expression MaxSearchRange = new Expression();
    public Expression FormVariable = new Expression();

	private float m_MaxDistance;
	private string m_TagName;
    public override void Start(RAIN.Core.AI ai)
    {
		m_TagName = TagVar.VariableName;
		m_MaxDistance = MaxSearchRange.Evaluate<float>(ai.DeltaTime, ai.WorkingMemory);
        base.Start(ai);
    }

    public override ActionResult Execute(RAIN.Core.AI ai)
    {
		Vector3 targetPosition = ai.Body.transform.position;
		RaycastHit hitPoint;

		Vector3 newPos = ai.Body.transform.position+new Vector3(Random.Range(-m_MaxDistance,m_MaxDistance),Random.Range(-m_MaxDistance,m_MaxDistance),Random.Range(-m_MaxDistance,m_MaxDistance));

		if (Physics.Raycast(newPos, Vector3.down, out hitPoint))
		{
			if(hitPoint.collider.tag.Equals(m_TagName.ToString()))
			{
				
				newPos=hitPoint.point;
				targetPosition=newPos;
				ai.WorkingMemory.SetItem<Vector3>(FormVariable.VariableName, targetPosition);
				return ActionResult.SUCCESS;
			}
			else
			{
				return ActionResult.FAILURE;
			}
		}
				
		return ActionResult.SUCCESS;
    }

    public override void Stop(RAIN.Core.AI ai)
    {
        base.Stop(ai);
    }

    private void GetPoint(RAIN.Core.AI ai)
    {
        
    }
}