﻿using UnityEngine;
using System.Collections;
using RAIN.Core;
using RAIN.Motion;
using RAIN.Serialization;

[RAINSerializableClass, RAINElement("Vehicle Motor")]
public class VehicleMotor : BasicMotor
{
    public override void ApplyMotionTransforms()
    {
        float priorSpeed = AI.Kinematic.PriorSpeed;
        float currentSpeed = AI.Kinematic.Speed;

        float newSpeed = Mathf.Lerp(priorSpeed, currentSpeed, AI.DeltaTime * 2f);

        AI.Kinematic.Velocity = AI.Body.transform.forward * newSpeed;

        base.ApplyMotionTransforms();
    }
}
