﻿using UnityEngine;


[ExecuteInEditMode]
public class CamEffect : MonoBehaviour
{
    public Material material;
    public float distortion;
    public float inputGamma;
    public float outputGamma;
    public float textureSize;

    void OnRenderImage(RenderTexture sourceTexture, RenderTexture destTexture)
    {
        material.SetFloat("_Distortion", distortion);
        material.SetFloat("_InputGamma", inputGamma);
        material.SetFloat("_OutputGamma", outputGamma);
        material.SetVector("_TextureSize", new Vector2(textureSize, textureSize));
        Graphics.Blit(sourceTexture, destTexture, material);
    }


}