﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Char_Movement : MonoBehaviour {
	public float axisx,axisz,movespeed, RightStep, LeftStep, moveTime;
	public Vector3 direction;
	public bool RightForward;
	public bool IsStepping;
	public float StepSize = 0.5f;
	public float StepProgress;
	public float StepSpeed = 2f;
	public Animator anim;


	// Use this for initialization
	void Start () {
		anim = GetComponent<Animator>();
		StepProgress = 0;
		IsStepping = false;
	}
	
	// Update is called once per frame
	void Update () {

		//transform.Translate(Vector3.forward * movespeed*Time.deltaTime);
		axisx = Input.GetAxis("Horizontal");
		axisz = Input.GetAxis("Vertical");
		direction = Quaternion.Euler(0,45,0) * new Vector3 (axisx,0,axisz);
		transform.LookAt (transform.position + direction);

		if (RightForward && Input.GetButtonDown ("Left Step")) {
			IsStepping = true;
			StepProgress = 0;
			anim.SetBool("LeftWalking",true);
			gameObject.GetComponent<TimedHits> ().Hit();
		} else if (!RightForward && Input.GetButtonDown ("Right Step")) {
			IsStepping = true;
			StepProgress = 0;
			anim.SetBool("LeftWalking",false);
			gameObject.GetComponent<TimedHits> ().Hit();
		}

		if (IsStepping) {
			StepProgress += Time.deltaTime * StepSpeed;
			if (StepProgress < 1) {
				transform.position += transform.forward * StepSize * Time.deltaTime;
			} else {
				IsStepping = false;
				StepProgress = 0;
				RightForward = !RightForward;
			}
		}
	}
}
