﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RadialWave : MonoBehaviour {
	public float Falloff = 10;
	public float StartHeight = 10;
	public float Speed = 5f;
	public float Height;
	public float Radius = 0;

	void Awake () {
		Height = StartHeight * (1 - Mathf.Lerp (0, Falloff, Radius));
	}

	void Update () {
		Radius += Time.deltaTime * Speed;
		Height = StartHeight * (Falloff - Radius) / Falloff;
	}
}
