﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class TimedHits : MonoBehaviour
{
    public float bpm;
    public int hitsPerInterval, numberOfIntervals;
	public float Leanancy;

    private int successCounter;
    private float interval;
	private bool m_hasTried;
	private bool m_sweetSpot;
	private bool m_succeeded;
	private float m_offset;

	public WaveGrid WaveGrid;
	public Scoring Scoring;
	public Text Prompt;

	private Color m_active = new Color(239/255f,170/255f,189/255f);
	private Color m_inactive = new Color(.5f,.5f,.5f,.5f);

    void Start ()
    {
		m_offset = Time.unscaledTime;
        if (bpm != 0) interval = 60 / bpm;
        else interval = 0;
		m_hasTried = false;
		m_sweetSpot = false;
		m_succeeded = false;

        StartCoroutine(Timer());
    }

	public void Hit() {
		if (!m_hasTried) {
			m_hasTried = true;
			if (m_sweetSpot) {
				Scoring.Score ();
				m_succeeded = true;
				WaveGrid.SpawnRadialWave(6,50);
				Prompt.color = Color.green;
			} else {
				Scoring.Miss ();
				Prompt.color = Color.red;
				WaveGrid.SpawnRadialWave(1,50);
			}
		}
	}

    IEnumerator Timer ()
    { 
        while (true)
        {
			float prog = (Time.time - m_offset) / interval;
            float accuracy = prog % 1;
			bool sweetSpot = accuracy < Leanancy || accuracy > (1 - Leanancy);

			if (m_sweetSpot != sweetSpot) {
				m_hasTried = false;
				if (sweetSpot) {
					Prompt.color = m_active;
				} else {
					Prompt.color = m_inactive;
					if (!m_succeeded) {
						Scoring.Miss ();
					}
					m_succeeded = false;
				}
				m_sweetSpot = sweetSpot;
			}

            yield return null;
        }
    }
}
